/**
 * Yum Food Orders
 * **Yum application, order food daily from the best chef in town**  This API is used by the angular.io client, and is not meant to be used otherwise.  Find source code of this API [here](http://gitlab/)  Copyright (C) 2017 JR Technologies.
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional } from '@angular/core';
import { Http, Headers, URLSearchParams } from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType } from '@angular/http';

import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS } from '../variables';
import { Configuration } from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class ChefApi {
  protected basePath = 'http://localhost:8082/api';
  public defaultHeaders: Headers = new Headers();
  public configuration: Configuration = new Configuration();

  constructor(protected http: Http, @Optional() @Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
    if (basePath) {
      this.basePath = basePath;
    }
    if (configuration) {
      this.configuration = configuration;
    }
  }

  /**
    * Gets a daily menu
    * Returns a daily menu matching the id.
    * @param id The Daily menus&#39;s id
    */
  public dailyMenusIdGet(id: number, extraHttpRequestParams?: any): Observable<models.DailyMenu> {
    return this.dailyMenusIdGetWithHttpInfo(id, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Edits a daily menu
   * Edits a daily menu matching the id.
   * @param id The Daily menus&#39;s id
   * @param dailyMenuToUpdate The daily menu to update.
   */
  public dailyMenusIdPut(id: number, dailyMenuToUpdate?: models.DailyMenuUpdate, extraHttpRequestParams?: any): Observable<models.DailyMenuUpdate> {
    return this.dailyMenusIdPutWithHttpInfo(id, dailyMenuToUpdate, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets daily menus of the current month.
   * Returns a list of daily menus of the current month.
   */
  public dailyMenusMonthlyGet(extraHttpRequestParams?: any): Observable<Array<models.DailyMenu>> {
    return this.dailyMenusMonthlyGetWithHttpInfo(extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets daily menus of the month chosen.
   * Returns a list of daily menus of the chosen month.
   * @param month The requested month
   */
  public dailyMenusMonthlyMonthGet(month: string, extraHttpRequestParams?: any): Observable<Array<models.DailyMenu>> {
    return this.dailyMenusMonthlyMonthGetWithHttpInfo(month, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Creates a daily menu for the day
   * creates a daily menu in the database
   * @param dailyMenu The daily menu to create.
   */
  public dailyMenusPost(dailyMenu?: models.DailyMenu, extraHttpRequestParams?: any): Observable<models.DailyMenu> {
    return this.dailyMenusPostWithHttpInfo(dailyMenu, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets a food item by its name
   * Returns a food item matching the name if it is not archived.
   * @param name The food&#39;s name that you want to search.
   */
  public foodsFindByNameNameGet(name: string, extraHttpRequestParams?: any): Observable<models.Food> {
    return this.foodsFindByNameNameGetWithHttpInfo(name, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Deletes a food.
   * deletes a food in the database
   * @param archived Select whether to delete or archive.
   * @param foodId The id of the food item to delete
   */
  public foodsFoodIdDelete(archived: number, foodId: number, extraHttpRequestParams?: any): Observable<{}> {
    return this.foodsFoodIdDeleteWithHttpInfo(archived, foodId, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets a food item
   * Returns a food item matching the foodId.
   * @param foodId The food&#39;s foodId
   * @param checkIfEditable Can edit all properties or only description.
   */
  public foodsFoodIdGet(foodId: number, checkIfEditable: boolean, extraHttpRequestParams?: any): Observable<models.FoodEdit> {
    return this.foodsFoodIdGetWithHttpInfo(foodId, checkIfEditable, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Updates a food.
   * updates a food in the database
   * @param foodId The id of the food item to update
   * @param clone Create a clone if food is not editable.
   * @param foodItemToUpdate The food to update.
   */
  public foodsFoodIdPut(foodId: number, clone: boolean, foodItemToUpdate?: models.FoodItem, extraHttpRequestParams?: any): Observable<{}> {
    return this.foodsFoodIdPutWithHttpInfo(foodId, clone, foodItemToUpdate, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets all foods.
   * Get all food items from database.
   * @param archived Show only archived or not foods.
   * @param page Show foods on certain page.
   * @param pagesize Show restricted amount of foods per page.
   * @param type Show only the selected type of food.
   * @param ordering Select ordering of foods.
   * @param version
   */
  public foodsGet(archived: boolean, page: number, pagesize: number, type: string, ordering: string, version?: number, extraHttpRequestParams?: any): Observable<models.Foods> {
    return this.foodsGetWithHttpInfo(archived, page, pagesize, type, ordering, version, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Creates a new food
   * creates a new food in the database
   * @param foodItem The new food to create.
   */
  public foodsPost(foodItem?: models.FoodItem, extraHttpRequestParams?: any): Observable<{}> {
    return this.foodsPostWithHttpInfo(foodItem, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets daily order summary.
   * Returns the daily order summary of the specified date.
   * @param day The requested day
   */
  public ordersDailyDayGet(day: number, extraHttpRequestParams?: any): Observable<models.DailySummary> {
    return this.ordersDailyDayGetWithHttpInfo(day, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets daily orders of the current month.
   * Returns a list of the monthly orders with every food the have including quantity and total price
   */
  public ordersMonthlyGet(extraHttpRequestParams?: any): Observable<Array<models.DailyOrderMonthSummary>> {
    return this.ordersMonthlyGetWithHttpInfo(extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
   * Gets monthly daily orders of a specific month.
   * Returns a list of daily orders of a specific month.
   * @param month The requested month
   */
  public ordersMonthlyMonthGet(month: string, extraHttpRequestParams?: any): Observable<Array<models.DailyOrderMonthSummary>> {
    return this.ordersMonthlyMonthGetWithHttpInfo(month, extraHttpRequestParams)
      .map((response: Response) => {
        if (response.status === 204) {
          return undefined;
        } else {
          return response.json();
        }
      });
  }

  /**
* Gets a daily menu
* Returns a daily menu matching the id.
* @param id The Daily menus&#39;s id
*/
  public dailyMenusIdGetWithHttpInfo(id: number, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/dailyMenus/${id}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'id' is not null or undefined
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling dailyMenusIdGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }


  /**
   * Gets a daily menu
   * Returns a daily menu matching the id.
   * @param id The Daily menus&#39;s id
   * @param dailyMenuToUpdate The daily menu to update.
   */
  public dailyMenusIdPutWithHttpInfo(id: number, dailyMenuToUpdate?: models.DailyMenuUpdate, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/dailyMenus/${id}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'id' is not null or undefined
    if (id === null || id === undefined) {
      throw new Error('Required parameter id was null or undefined when calling dailyMenusIdPut.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Put,
      headers: headers,
      body: dailyMenuToUpdate == null ? '' : JSON.stringify(dailyMenuToUpdate), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets daily menus of the current month.
   * Returns a list of daily menus of the current month.
   */
  public dailyMenusMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/dailyMenus/monthly`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets daily menus of the month chosen.
   * Returns a list of daily menus of the chosen month.
   * @param month The requested month
   */
  public dailyMenusMonthlyMonthGetWithHttpInfo(month: string, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/dailyMenus/monthly/${month}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'month' is not null or undefined
    if (month === null || month === undefined) {
      throw new Error('Required parameter month was null or undefined when calling dailyMenusMonthlyMonthGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Creates a daily menu for the day
   * creates a daily menu in the database
   * @param dailyMenu The daily menu to create.
   */
  public dailyMenusPostWithHttpInfo(dailyMenu?: models.DailyMenu, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/dailyMenus`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Post,
      headers: headers,
      body: dailyMenu == null ? '' : JSON.stringify(dailyMenu), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets a food item by its name
   * Returns a food item matching the name if it is not archived.
   * @param name The food&#39;s name that you want to search.
   */
  public foodsFindByNameNameGetWithHttpInfo(name: string, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/foods/findByName/${name}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'name' is not null or undefined
    if (name === null || name === undefined) {
      throw new Error('Required parameter name was null or undefined when calling foodsFindByNameNameGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Deletes a food.
   * deletes a food in the database
   * @param archived Select whether to delete or archive.
   * @param foodId The id of the food item to delete
   */
  public foodsFoodIdDeleteWithHttpInfo(archived: number, foodId: number, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/foods/${foodId}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'archived' is not null or undefined
    if (archived === null || archived === undefined) {
      throw new Error('Required parameter archived was null or undefined when calling foodsFoodIdDelete.');
    }
    // verify required parameter 'foodId' is not null or undefined
    if (foodId === null || foodId === undefined) {
      throw new Error('Required parameter foodId was null or undefined when calling foodsFoodIdDelete.');
    }
    if (archived !== undefined) {

      queryParameters.set('archived', <any>archived);

    }

    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Delete,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets a food item
   * Returns a food item matching the foodId.
   * @param foodId The food&#39;s foodId
   * @param checkIfEditable Can edit all properties or only description.
   */
  public foodsFoodIdGetWithHttpInfo(foodId: number, checkIfEditable: boolean, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/foods/${foodId}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'foodId' is not null or undefined
    if (foodId === null || foodId === undefined) {
      throw new Error('Required parameter foodId was null or undefined when calling foodsFoodIdGet.');
    }
    // verify required parameter 'checkIfEditable' is not null or undefined
    if (checkIfEditable === null || checkIfEditable === undefined) {
      throw new Error('Required parameter checkIfEditable was null or undefined when calling foodsFoodIdGet.');
    }
    if (checkIfEditable !== undefined) {

      queryParameters.set('checkIfEditable', <any>checkIfEditable);

    }

    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Updates a food.
   * updates a food in the database
   * @param foodId The id of the food item to update
   * @param clone Create a clone if food is not editable.
   * @param foodItemToUpdate The food to update.
   */
  public foodsFoodIdPutWithHttpInfo(foodId: number, clone: boolean, foodItemToUpdate?: models.FoodItem, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/foods/${foodId}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'foodId' is not null or undefined
    if (foodId === null || foodId === undefined) {
      throw new Error('Required parameter foodId was null or undefined when calling foodsFoodIdPut.');
    }
    // verify required parameter 'clone' is not null or undefined
    if (clone === null || clone === undefined) {
      throw new Error('Required parameter clone was null or undefined when calling foodsFoodIdPut.');
    }
    if (clone !== undefined) {

      queryParameters.set('clone', <any>clone);

    }

    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Put,
      headers: headers,
      body: foodItemToUpdate == null ? '' : JSON.stringify(foodItemToUpdate), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets all foods.
   * Get all food items from database.
   * @param archived Show only archived or not foods.
   * @param page Show foods on certain page.
   * @param pagesize Show restricted amount of foods per page.
   * @param type Show only the selected type of food.
   * @param ordering Select ordering of foods.
   * @param version
   */
  public foodsGetWithHttpInfo(archived: boolean, page: number, pagesize: number, type: string, ordering: string, version?: number, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/foods`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'archived' is not null or undefined
    if (archived === null || archived === undefined) {
      throw new Error('Required parameter archived was null or undefined when calling foodsGet.');
    }
    // verify required parameter 'page' is not null or undefined
    if (page === null || page === undefined) {
      throw new Error('Required parameter page was null or undefined when calling foodsGet.');
    }
    // verify required parameter 'pagesize' is not null or undefined
    if (pagesize === null || pagesize === undefined) {
      throw new Error('Required parameter pagesize was null or undefined when calling foodsGet.');
    }
    // verify required parameter 'type' is not null or undefined
    if (type === null || type === undefined) {
      throw new Error('Required parameter type was null or undefined when calling foodsGet.');
    }
    // verify required parameter 'ordering' is not null or undefined
    if (ordering === null || ordering === undefined) {
      throw new Error('Required parameter ordering was null or undefined when calling foodsGet.');
    }
    if (version !== undefined) {

      queryParameters.set('version', <any>version);

    }

    if (archived !== undefined) {

      queryParameters.set('archived', <any>archived);

    }

    if (page !== undefined) {

      queryParameters.set('page', <any>page);

    }

    if (pagesize !== undefined) {

      queryParameters.set('pagesize', <any>pagesize);

    }

    if (type !== undefined) {

      queryParameters.set('type', <any>type);

    }

    if (ordering !== undefined) {

      queryParameters.set('ordering', <any>ordering);

    }

    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Creates a new food
   * creates a new food in the database
   * @param foodItem The new food to create.
   */
  public foodsPostWithHttpInfo(foodItem?: models.FoodItem, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/foods`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    headers.set('Content-Type', 'application/json');

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Post,
      headers: headers,
      body: foodItem == null ? '' : JSON.stringify(foodItem), // https://github.com/angular/angular/issues/10612
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets daily order summary.
   * Returns the daily order summary of the specified date.
   * @param day The requested day
   */
  public ordersDailyDayGetWithHttpInfo(day: number, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders/daily/${day}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'day' is not null or undefined
    if (day === null || day === undefined) {
      throw new Error('Required parameter day was null or undefined when calling ordersDailyDayGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets daily orders of the current month.
   * Returns a list of the monthly orders with every food the have including quantity and total price
   */
  public ordersMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders/monthly`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

  /**
   * Gets monthly daily orders of a specific month.
   * Returns a list of daily orders of a specific month.
   * @param month The requested month
   */
  public ordersMonthlyMonthGetWithHttpInfo(month: string, extraHttpRequestParams?: any): Observable<Response> {
    const path = this.basePath + `/orders/monthly/${month}`;

    let queryParameters = new URLSearchParams();
    let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
    // verify required parameter 'month' is not null or undefined
    if (month === null || month === undefined) {
      throw new Error('Required parameter month was null or undefined when calling ordersMonthlyMonthGet.');
    }
    // to determine the Content-Type header
    let consumes: string[] = [
    ];

    // to determine the Accept header
    let produces: string[] = [
      'application/json'
    ];

    // authentication (Bearer) required
    if (this.configuration.apiKey) {
      headers.set('Authorization', this.configuration.apiKey);
    }

    let requestOptions: RequestOptionsArgs = new RequestOptions({
      method: RequestMethod.Get,
      headers: headers,
      search: queryParameters
    });

    // https://github.com/swagger-api/swagger-codegen/issues/4037
    if (extraHttpRequestParams) {
      requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
    }

    return this.http.request(path, requestOptions);
  }

}
